#
# smtp/pop/http code examples (not work, just example)
#

#------------------------------------------------------------#

smtp = Net::SMTP.new( host, port )
smtp.start( helo ) do
  # write from string (not safe if mail is big)
  smtp.sendmail string, from, to

  # write from file (safe)
  smtp.sendmail input_file, from, to

  # write from array of string (not safe)
  smtp.sendmail arr, from, to

  # write little string at one iteration
  smtp.ready( from, to ) do |f|
    f.write str1
    f.write str2
    f.write str3
  end
end

#------------------------------------------------------------#

Net::POP.start( addr, port, account, passwd ) do |pop|
  pop.each do |mail|
    print mail.top 25   # print header & 25 lines
    print mail.pop      # print all

    # write to string (not safe if mail is too big)
    str = mail.pop

    # write to file (safe)
    mail.pop( output_file )

    # get little string at one iteration
    # (safe if written object is not on memory)
    mail.pop do |str|
      print str
    end

    mail.delete
  end
end

#------------------------------------------------------------#

Net::HTTP.start( addr, port ) do |http|

  # body is written into string
  response = http.get( '/ja/' )

  # ...is equal to:
  str = ''
  http.get( '/ja/', nil, str )

  # write into file
  http.get( '/ja/', nil, output_file )

  # or
  req = Net::HTTP::Get.new( '/ja/' )
  http.request( req ) do |response|
    str = response.read_body
  end

  # or
  req = Net::HTTP::Get.new( '/ja/' )
  http.request( req ) do |response|
    File.open( 'file/name/you/want', 'w' ) {|f|
      response.read_body do |str|
        f.write str
      end
      # You can enshort this code like: "response.read_body(f)"
    }
  end

  # post data
  response = http.post( '/cgi-bin/procdata.rb', 'data data data...' )

end

#------------------------------------------------------------#
#
# http get
#

response = nil
ok = false
until ok do
  Net::HTTP.start( addr, port ) do |http|
    response = http.get( .... )

    case response
    when Net::SuccessCode
      ok = true
    when Net::RetriableCode
      # change address and retry
      addr = xxxx
      port = xxxx
    else
      raise
    end
  end
end

#------------------------------------------------------------#
#
# http get, with get request
#

# moved document
path = '/ja/index.html'
req = Net::HTTP::Get.new( path )

Net::HTTP.start( addr, port ) do |http|

  ok = false
  until ok do
    http.request( req ) do |response|
      case response
      when Net::SuccessCode
        ok = true
        do_something( response.read_body )

      when Net::RetriableCode
        case response
        when Net::HTTPMovedTemporarily, Net::HTTPMovedPermanently
          req = Net::HTTP::Get.new( response['location'] )
        else
          # can't process
        end

      when Net::FatalErrorCode
        raise
      else
        # can't process
      end
    end
  end

end

#------------------------------------------------------------#

print Net::HTTP.new(addr).get(path).body
# Omitting start is also ok. The connection is closed after get.
# But I do NOT recommend this.

#------------------------------------------------------------#
